/*
Dataddo Headless BETA API

Dataddo Headless BETA API

API version: 1.0.0-beta.1
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package customer_api

import (
	"encoding/json"
)

// checks if the RedshiftDto type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &RedshiftDto{}

// RedshiftDto struct for RedshiftDto
type RedshiftDto struct {
	ConnectorId *string `json:"connectorId,omitempty"`
	TemplateId  *string `json:"templateId,omitempty"`
	Label       *string `json:"label,omitempty"`
	Strategy    *string `json:"strategy,omitempty"`
	OAuthId     *int32  `json:"o_auth_id,omitempty"`
	Statement   *string `json:"statement,omitempty"`
	StorageId   *string `json:"storageId,omitempty"`
}

// NewRedshiftDto instantiates a new RedshiftDto object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewRedshiftDto() *RedshiftDto {
	this := RedshiftDto{}
	return &this
}

// NewRedshiftDtoWithDefaults instantiates a new RedshiftDto object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewRedshiftDtoWithDefaults() *RedshiftDto {
	this := RedshiftDto{}
	return &this
}

// GetConnectorId returns the ConnectorId field value if set, zero value otherwise.
func (o *RedshiftDto) GetConnectorId() string {
	if o == nil || IsNil(o.ConnectorId) {
		var ret string
		return ret
	}
	return *o.ConnectorId
}

// GetConnectorIdOk returns a tuple with the ConnectorId field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *RedshiftDto) GetConnectorIdOk() (*string, bool) {
	if o == nil || IsNil(o.ConnectorId) {
		return nil, false
	}
	return o.ConnectorId, true
}

// HasConnectorId returns a boolean if a field has been set.
func (o *RedshiftDto) HasConnectorId() bool {
	if o != nil && !IsNil(o.ConnectorId) {
		return true
	}

	return false
}

// SetConnectorId gets a reference to the given string and assigns it to the ConnectorId field.
func (o *RedshiftDto) SetConnectorId(v string) {
	o.ConnectorId = &v
}

// GetTemplateId returns the TemplateId field value if set, zero value otherwise.
func (o *RedshiftDto) GetTemplateId() string {
	if o == nil || IsNil(o.TemplateId) {
		var ret string
		return ret
	}
	return *o.TemplateId
}

// GetTemplateIdOk returns a tuple with the TemplateId field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *RedshiftDto) GetTemplateIdOk() (*string, bool) {
	if o == nil || IsNil(o.TemplateId) {
		return nil, false
	}
	return o.TemplateId, true
}

// HasTemplateId returns a boolean if a field has been set.
func (o *RedshiftDto) HasTemplateId() bool {
	if o != nil && !IsNil(o.TemplateId) {
		return true
	}

	return false
}

// SetTemplateId gets a reference to the given string and assigns it to the TemplateId field.
func (o *RedshiftDto) SetTemplateId(v string) {
	o.TemplateId = &v
}

// GetLabel returns the Label field value if set, zero value otherwise.
func (o *RedshiftDto) GetLabel() string {
	if o == nil || IsNil(o.Label) {
		var ret string
		return ret
	}
	return *o.Label
}

// GetLabelOk returns a tuple with the Label field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *RedshiftDto) GetLabelOk() (*string, bool) {
	if o == nil || IsNil(o.Label) {
		return nil, false
	}
	return o.Label, true
}

// HasLabel returns a boolean if a field has been set.
func (o *RedshiftDto) HasLabel() bool {
	if o != nil && !IsNil(o.Label) {
		return true
	}

	return false
}

// SetLabel gets a reference to the given string and assigns it to the Label field.
func (o *RedshiftDto) SetLabel(v string) {
	o.Label = &v
}

// GetStrategy returns the Strategy field value if set, zero value otherwise.
func (o *RedshiftDto) GetStrategy() string {
	if o == nil || IsNil(o.Strategy) {
		var ret string
		return ret
	}
	return *o.Strategy
}

// GetStrategyOk returns a tuple with the Strategy field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *RedshiftDto) GetStrategyOk() (*string, bool) {
	if o == nil || IsNil(o.Strategy) {
		return nil, false
	}
	return o.Strategy, true
}

// HasStrategy returns a boolean if a field has been set.
func (o *RedshiftDto) HasStrategy() bool {
	if o != nil && !IsNil(o.Strategy) {
		return true
	}

	return false
}

// SetStrategy gets a reference to the given string and assigns it to the Strategy field.
func (o *RedshiftDto) SetStrategy(v string) {
	o.Strategy = &v
}

// GetOAuthId returns the OAuthId field value if set, zero value otherwise.
func (o *RedshiftDto) GetOAuthId() int32 {
	if o == nil || IsNil(o.OAuthId) {
		var ret int32
		return ret
	}
	return *o.OAuthId
}

// GetOAuthIdOk returns a tuple with the OAuthId field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *RedshiftDto) GetOAuthIdOk() (*int32, bool) {
	if o == nil || IsNil(o.OAuthId) {
		return nil, false
	}
	return o.OAuthId, true
}

// HasOAuthId returns a boolean if a field has been set.
func (o *RedshiftDto) HasOAuthId() bool {
	if o != nil && !IsNil(o.OAuthId) {
		return true
	}

	return false
}

// SetOAuthId gets a reference to the given int32 and assigns it to the OAuthId field.
func (o *RedshiftDto) SetOAuthId(v int32) {
	o.OAuthId = &v
}

// GetStatement returns the Statement field value if set, zero value otherwise.
func (o *RedshiftDto) GetStatement() string {
	if o == nil || IsNil(o.Statement) {
		var ret string
		return ret
	}
	return *o.Statement
}

// GetStatementOk returns a tuple with the Statement field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *RedshiftDto) GetStatementOk() (*string, bool) {
	if o == nil || IsNil(o.Statement) {
		return nil, false
	}
	return o.Statement, true
}

// HasStatement returns a boolean if a field has been set.
func (o *RedshiftDto) HasStatement() bool {
	if o != nil && !IsNil(o.Statement) {
		return true
	}

	return false
}

// SetStatement gets a reference to the given string and assigns it to the Statement field.
func (o *RedshiftDto) SetStatement(v string) {
	o.Statement = &v
}

// GetStorageId returns the StorageId field value if set, zero value otherwise.
func (o *RedshiftDto) GetStorageId() string {
	if o == nil || IsNil(o.StorageId) {
		var ret string
		return ret
	}
	return *o.StorageId
}

// GetStorageIdOk returns a tuple with the StorageId field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *RedshiftDto) GetStorageIdOk() (*string, bool) {
	if o == nil || IsNil(o.StorageId) {
		return nil, false
	}
	return o.StorageId, true
}

// HasStorageId returns a boolean if a field has been set.
func (o *RedshiftDto) HasStorageId() bool {
	if o != nil && !IsNil(o.StorageId) {
		return true
	}

	return false
}

// SetStorageId gets a reference to the given string and assigns it to the StorageId field.
func (o *RedshiftDto) SetStorageId(v string) {
	o.StorageId = &v
}

func (o RedshiftDto) MarshalJSON() ([]byte, error) {
	toSerialize, err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o RedshiftDto) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	if !IsNil(o.ConnectorId) {
		toSerialize["connectorId"] = o.ConnectorId
	}
	if !IsNil(o.TemplateId) {
		toSerialize["templateId"] = o.TemplateId
	}
	if !IsNil(o.Label) {
		toSerialize["label"] = o.Label
	}
	if !IsNil(o.Strategy) {
		toSerialize["strategy"] = o.Strategy
	}
	if !IsNil(o.OAuthId) {
		toSerialize["o_auth_id"] = o.OAuthId
	}
	if !IsNil(o.Statement) {
		toSerialize["statement"] = o.Statement
	}
	if !IsNil(o.StorageId) {
		toSerialize["storageId"] = o.StorageId
	}
	return toSerialize, nil
}

type NullableRedshiftDto struct {
	value *RedshiftDto
	isSet bool
}

func (v NullableRedshiftDto) Get() *RedshiftDto {
	return v.value
}

func (v *NullableRedshiftDto) Set(val *RedshiftDto) {
	v.value = val
	v.isSet = true
}

func (v NullableRedshiftDto) IsSet() bool {
	return v.isSet
}

func (v *NullableRedshiftDto) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableRedshiftDto(val *RedshiftDto) *NullableRedshiftDto {
	return &NullableRedshiftDto{value: val, isSet: true}
}

func (v NullableRedshiftDto) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableRedshiftDto) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}
